using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PierwszaGra
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //VertexPositionColor[] tablicaWerteksw = new VertexPositionColor[3]
        //{
        //    new VertexPositionColor(new Vector3(0.5f,-0.5f,0),Color.Cyan),
        //    new VertexPositionColor(new Vector3(-0.5f,-0.5f,0),Color.Magenta),
        //    new VertexPositionColor(new Vector3(0,1,0),Color.Yellow)
        //};
        VertexPositionColor[] tablicaWerteksw = new VertexPositionColor[4]
        {
            new VertexPositionColor(new Vector3(0.5f,-0.5f,0),Color.Cyan),
            new VertexPositionColor(new Vector3(-0.5f,-0.5f,0),Color.Magenta),
            new VertexPositionColor(new Vector3(0.5f,0.5f,0),Color.Yellow),
            new VertexPositionColor(new Vector3(-0.5f,0.5f,0),Color.White)
        };

        BasicEffect efekt;

        VertexBuffer buforWerteksw;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            this.IsMouseVisible = true;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            efekt = new BasicEffect(this.graphics.GraphicsDevice);
            efekt.VertexColorEnabled = true;

            //efekt.Projection = Matrix.CreateOrthographic(2, 2, 0, 100);
            //efekt.Projection = Matrix.CreatePerspective(2 * graphics.GraphicsDevice.Viewport.AspectRatio, 2, 1, 100);
            efekt.Projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.PiOver2, graphics.GraphicsDevice.Viewport.AspectRatio, 1, 100);
            efekt.View = Matrix.CreateLookAt(1.5f * Vector3.UnitZ, Vector3.Zero, Vector3.Up);
            efekt.World = Matrix.Identity;

            buforWerteksw = new VertexBuffer(
                graphics.GraphicsDevice,
                VertexPositionColor.VertexDeclaration,
                tablicaWerteksw.Count(),
                BufferUsage.WriteOnly);
            buforWerteksw.SetData<VertexPositionColor>(tablicaWerteksw);

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            if (!this.IsActive) return;

            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            //efekt.World *= Matrix.CreateRotationZ(1f*(float)gameTime.ElapsedGameTime.TotalSeconds);
            //efekt.World *= Matrix.CreateRotationY(1f * (float)gameTime.ElapsedGameTime.TotalSeconds);

            if (Keyboard.GetState().IsKeyDown(Keys.Left)) 
                efekt.World *= Matrix.CreateRotationZ(1f * (float)gameTime.ElapsedGameTime.TotalSeconds);
            if (Keyboard.GetState().IsKeyDown(Keys.Right)) 
                efekt.World *= Matrix.CreateRotationZ(-1f * (float)gameTime.ElapsedGameTime.TotalSeconds);
            if (Keyboard.GetState().IsKeyDown(Keys.Up)) 
                efekt.World *= Matrix.CreateRotationX(-1f * (float)gameTime.ElapsedGameTime.TotalSeconds);
            if (Keyboard.GetState().IsKeyDown(Keys.Down)) 
                efekt.World *= Matrix.CreateRotationX(1f * (float)gameTime.ElapsedGameTime.TotalSeconds);

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            //if (!this.IsActive) return;

            //GraphicsDevice.Clear(Color.CornflowerBlue);
            GraphicsDevice gd = GraphicsDevice;
            gd.Clear(Color.Black);

            //gd.RasterizerState = RasterizerState.CullNone;
            gd.RasterizerState = new RasterizerState
            {
                CullMode = CullMode.CullCounterClockwiseFace,
                FillMode = FillMode.Solid
            };

            gd.SetVertexBuffer(buforWerteksw);
            foreach (EffectPass pass in efekt.CurrentTechnique.Passes)
            {
                pass.Apply();

                //gd.DrawUserPrimitives(PrimitiveType.TriangleList, tablicaWerteksw, 0, 1);
                //gd.DrawPrimitives(PrimitiveType.TriangleList, 0, 1);
                gd.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2);
            }

            base.Draw(gameTime);
        }
    }
}
